## Mathematikinformation Nr. 71 / 72
## Lei Baozhen, Beijing Union University
## Harald Loewe, Technische Universitaet Braunschweig
## Numerische Verfahren zur Loesung von Differentialgleichungen
##
##############################################################
### Initialisierung des AWP fuer Escherichia coli          ###
##############################################################
##
## Ver. 2019-12-15
## Kodierung in UTF-8; Octave-Version 5.10

## Aufraeumen
clear -all;
clf;

## Anfangswertproblem fuer Escherichia coli:
kp  = 0.035;                # Wachstumsparameter
f   = @(t,x) kp*x;          # rechte Seite
t0  = 0;                    # Intervall-Anfang
T   = 60;                   # Intervall-Ende
x0  = 10^5;                 # Anfangswert

## Exakte Loesung:
xe  = @(t) x0*exp(kp*t);    # Exakte Loesung als Funktion
tte = [0:1:T];              # Stuetzstellen fuer exakte Loesung