## 2019 Mathematikinformation Nr. 71
## Lei Baozhen, Beijing Union University
## Harald Loewe, Technische Universitaet Braunschweig
## Numerische Verfahren zur Loesung von Differentialgleichungen
##
##############################################################
### Initialisierung des AWP fuer das logistische Wachstum  ###
##############################################################
##
## Ver. 2019-12-15
## Kodierung in UTF-8; Octave-Version 5.10

## Aufraeumen
clear -all;
clf;

## Anfangswertproblem
r     = 0.0017;       # Wachstumsrate
K     = 10000;        # Grenzbestand
t0    = 0;            # Intervallanfang
T     = 2;            # Intervallende
f     = @(t,x) r*x*(K-x); # rechte Seite der Differentialgleichung
x0    = 3;            # Anfangsbestand

## Exakte Loesung und deren Graph
xe    = @(t) K./(1+(K-x0)/x0*exp(-r*K*t));
tte   = 0:0.01:T;