## Mathematikinformation Nr. 71 / 72
## Lei Baozhen, Beijing Union University
## Harald Loewe, Technische Universitaet Braunschweig
## Numerische Verfahren zur Loesung von Differentialgleichungen
##
##############################################################
### Initialisierung des AWP fuer den Zerfall von Radon     ###
##############################################################
##
## Ver. 2019-12-15
## Kodierung in UTF-8; Octave-Version 5.10

## Aufraeumen
clear -all;
clf;

## Anfangswertproblem fuer den Zerfall von Radon:
kp  = -0.1824;              # Zerfallskonstante
f   = @(t,x) kp*x;          # rechte Seite
t0  = 0;                    # Intervall-Anfang
T   = 365;                  # Intervall-Ende (365 Tage)
x0  = 10^3;                 # Anfangswert    (1000 kg)

## Exakte Loesung:
xe  = @(t) x0*exp(kp*t);    # Exakte Loesung als Funktion
tte = [0:1:T];              # Stuetzstellen fuer exakte Loesung