## Mathematikinformation Nr. 71
## Lei Baozhen, Beijing Union University
## Harald Loewe, Technische Universitaet Braunschweig
## Numerische Verfahren zur Loesung von Differentialgleichungen
##
##############################################################
### Loesung von Aufgabe 1_4_1                              ###
##############################################################
##
## Eulersches Polygonzugverfahren
## Ver. 2019-12-15
## Kodierung in UTF-8; Octave-Version 5.10

## Initialisierung des Anfangswertproblems
AWP_init_141;

###################################
## Festlegen der Schrittweite dt ##
###################################
dt = 0.115;

## Polygonzugverfahren auf dem Intervall [0,1] durchfuehren
T   = 1;
## Sorge dafuer, dass die Schrittzahl N eine natuerliche Zahl ist!
N   = floor(T/dt);         # "floor" rundet ab
                           # "ceil" rundet auf, falls gewuenscht
## ttt = Liste der Stuetzstellen t_k
ttt    = [0:dt:T];
## xxx = Liste der Werte
xxx    = zeros(1,N+1);    # Initialisierung der Liste
xxx(1) = x0;              # erster Wert ist Anfangswert
## Befuelle die Liste
for k = 1:N               # Eulersches Polygonzugverfahren
  xxx(k+1) = xxx(k) + dt * f(ttt(k),xxx(k));
endfor;

## Plot der Ergebnisse als Subplot
figure(1)
  subplot (1, 2, 1)
    plot(tte1,xe(tte1),'linewidth',2,'color',[.5 .5 .5]);
    hold on
    plot(ttt,xxx,'-o','linewidth',3,'color','black');
    xlabel('t'), ylabel('x(t)')
    title(['Loesung auf [0,1]';' Zeitschritt = ', num2str(dt)])
    set(gca,'linewidth',2,'fontsize',20)
    hold off

## Polygonzugverfahren auf dem Intervall [0,2] durchfuehren
T   = 2;
## Sorge dafuer, dass die Schrittzahl N eine natuerliche Zahl ist!!!!
N   = floor(T/dt);         # "floor" rundet ab
                           # "ceil" rundet auf, falls gewuenscht
## ttt = Liste der Stuetzstellen t_k
ttt    = [0:dt:T];
## xxx = Liste der Werte
xxx    = zeros(1,N+1);    # Initialisierung der Liste
xxx(1) = x0;              # erster Wert ist Anfangswert
## Befuelle die Liste
for k = 1:N               # Eigentliches Verfahren
  xxx(k+1) = xxx(k) + dt * f(ttt(k),xxx(k));
endfor;    

## Plot des Ergebnisses als Subplot
figure(1)
  subplot (1, 2, 2)
    plot(tte1,xe(tte1),'linewidth',2,'color',[.5 .5 .5],...
         tte2,xe(tte2),'linewidth',2,'color',[.5 .5 .5]);
    hold on
    plot(ttt,xxx,'-o','linewidth',3,'color','black')
    xlabel('t'), ylabel('x(t)')
    title(['Loesung auf [0,1]';' Zeitschritt = ', num2str(dt)])
    set(gca,'linewidth',2,'fontsize',20)
    hold off


## Abspeichern als Bild in akzeptabler Aufloesung.
## Veraendern von dt passt den Dateinamen an.
## Falls die Marker keine Kreise sind: "-painters" als Option einfuegen!
print ("-r600", "-painters", ["Aufgabe_1_4_1_dt=",num2str(dt),".png"]);


