## Mathematikinformation Nr. 71 / 72
## http://mathematikinformation.info/
##
## Lei Baozhen, Beijing Union University
## Harald Loewe, Technische Universitaet Braunschweig
## Numerische Verfahren zur Loesung von Differentialgleichungen
##
##############################################################
### Loesung von Aufgabe 1_4_1                              ###
### Variante: Loesung per Script ODE_PZ                    ###
##############################################################
##
## Ver. 2019-12-15
## Kodierung in UTF-8; Octave-Version 5.10

## Initialisierung
AWP_init_141;

###################################
## Festlegen der Schrittweite dt ##
###################################
dt = 1/3;

## Polygonzugverfahren fuer das Intervall [0,1] aufrufen
erg = ODE_PZ(f, t0, 1, x0, dt);

## Plot der Ergebnisse als Subplot
figure(1)
  subplot (1, 2, 1)
    plot(tte1,xe(tte1),'linewidth',2,'color',[.5 .5 .5]);
    hold on
    plot(erg(1,:),erg(2,:),'-o','linewidth',3,'color','black');
    xlabel('t'), ylabel('x(t)')
    title(['Loesung auf [0,1]';' Zeitschritt = ', num2str(dt)])
    set(gca,'linewidth',2,'fontsize',20)
    hold off

## Polygonzugverfahren fuer das Intervall [0,2] aufrufen
erg = ODE_PZ(f, t0, 2, x0, dt);

## Plot des Ergebnisses als Subplot
figure(1)
  subplot (1, 2, 2)
    plot(tte1,xe(tte1),'linewidth',2,'color',[.5 .5 .5],...
         tte2,xe(tte2),'linewidth',2,'color',[.5 .5 .5]);
    hold on
    plot(erg(1,:),erg(2,:),'-o','linewidth',3,'color','black')
    xlabel('t'), ylabel('x(t)')
    title(['Loesung auf [0,2]';' Zeitschritt = ', num2str(dt)])
    set(gca,'linewidth',2,'fontsize',20)
    hold off


# Abspeichern als Bild in akzeptabler Aufloesung.
# Veraendern von T oder N passt den Dateinamen an.
# Falls die Marker keine Kreise sind: "-painters" als Option einfuegen!
print ("-r600", "-painters", ["Aufgabe_1_4_1_dt=",num2str(dt),".png"]);


