## Mathematikinformation Nr. 71 / 72
## http://mathematikinformation.info/
##
## Lei Baozhen, Beijing Union University
## Harald Loewe, Technische Universitaet Braunschweig
## Numerische Verfahren zur Loesung von Differentialgleichungen
##
##############################################################
### Zu Aufgabe 1.6.5 / Intervall [0; 10]                   ###
##############################################################
##
## Ver. 2019-12-15
## Kodierung in UTF-8; Octave-Version 5.10

# Initialiserung des Anfangswertproblems
AWP_init_165;

# Festlegen der Anzahl der Schritte
N_list = [240 249 250 251 260 500];

# Wir moechten die Ergebnisse zusammen in einem 2x6-Bild erhalten...
for lauf1 = 1:1:2
 for lauf2 = 1:1:3
 # Die Loesung wird fuer alle gewaehlten Werte von dt berechnet.
 N  = N_list(3*(lauf1-1)+lauf2);
 dt = T/N;
 # Loesung per Polygonzugverfahren
 erg = ODE_PZ(f, t0, T, x0, dt);


# Plot der Ergebnisse als Subplot
 h = figure(1);
 set (h,'papersize',[25 10])
 set (h, 'paperposition', [0,0,[25 10]]);
   subplot (2, 3, 3*(lauf1-1)+lauf2)
     hold on
     plot(erg(1,:),erg(2,:),'linewidth',3,'color','black');
     # Exakte Loesung UEBER der Naeherung, daher als zweites plotten
     plot(tte,xe(tte),'linewidth',2,'color',[.5 .5 .5]);
     xlabel('t'), ylabel('x(t)')
     title(['N = ', num2str(N),'; dt = ', num2str(dt)])
     set(gca,'linewidth',2,'fontsize',18)
     hold off

endfor;
endfor;

# Abspeichern als Bild in akzeptabler Aufloesung.
# Falls die Marker keine Kreise sind: "-painters" als Option einfuegen!
print ("-r600", "-painters", ["Aufgabe_1_6_5a.png"]);


