## Mathematikinformation Nr. 71 / 72
## http://mathematikinformation.info/
##
## Lei Baozhen, Beijing Union University
## Harald Loewe, Technische Universitaet Braunschweig
## Numerische Verfahren zur Loesung von Differentialgleichungen
##
##############################################################
### Zu Aufgabe 1.6.5 / Intervall [0; 10]                   ###
##############################################################
##
## Ver. 2019-12-15
## Kodierung in UTF-8; Octave-Version 5.10

# Initialiserung des Anfangswertproblems
AWP_init_165;
# Lege t0, T, x0 neu fest
t0  = pi;                  # Intervall faengt erst ab pi an!
x0  = exp(-50*t0)-1;       # Neuer Anfangswert
T   = 10+pi;               # Intervallende (in Tagen)

#######################################
## Festlegen der Anzahl der Schritte ##
#######################################
N_list = [246 247 248];

# Wir moechten die Ergebnisse zusammen in einem 1x3-Bild erhalten...
for lauf = 1:1:3
 N  = N_list(lauf);
 dt = (T-t0)/N;                # Schrittweite auf das Intervall anpassen
 erg = ODE_PZ(f, t0, T, x0, dt);

# Plot der Ergebnisse als Subplot
 h = figure(1);
 set (h,'papersize',[25 5])
 set (h, 'paperposition', [0,0,[25 5]]);
   subplot (1, 3, lauf)
     hold on
     plot(erg(1,:),erg(2,:),'linewidth',3,'color','black');
     # Exakte Loesung UEBER der Naeherung, daher als zweites plotten
     plot(tte,xe(tte),'linewidth',2,'color',[.5 .5 .5]);
     xlabel('t'), ylabel('x(t)')
     title(['N = ', num2str(N),'; dt = ', num2str(dt)])
     set(gca,'linewidth',2,'fontsize',18)
     hold off
endfor;

# Abspeichern als Bild in akzeptabler Aufloesung.
# Falls die Marker keine Kreise sind: "-painters" als Option einfuegen!
print ("-r600", "-painters", ["Aufgabe_1_6_5b.png"]);