## Mathematikinformation Nr. 71 / 72
## http://mathematikinformation.info/
##
## Lei Baozhen, Beijing Union University
## Harald Loewe, Technische Universitaet Braunschweig
## Numerische Verfahren zur Loesung von Differentialgleichungen
##
##############################################################
### Zu Aufgabe 1.7.4: Beispiel fuer ODE_PZSW               ###
##############################################################
##
## Ver. 2019-12-15
## Kodierung in UTF-8; Octave-Version 5.10

## Initialisierung des Anfangswertproblems aus Aufgabe 1.6.5
AWP_init_165;

## Zeitnahme
tic;
## Durchfuehren des Polygonzugverfahrens mit Schrittweitensteuerung;
## akzeptabler lokaler Fehler "alpha" ist 10^-2
## Sicherheitsfaktor "sigma" fuer neue Schrittweite ist 0.8
alf   = 10^-2;
sig   = 0.8;
erg   = ODE_PZSW(f, t0, T, x0,{'alpha',alf,'sigma',sig});
## Zeitnahme
Zeit  = toc;
### Hinweis:
### Die Zeitberechnung per tic und toc ist eher eine grobe Schaetzung!
### Sie haengt unter anderem von weiteren laufenden Prozesse des 
### Betriebssystems ab.


## Auslesen der Stuetzstellen
ttt          = erg(1,:);
## Schrittzahl = Anzahl der Stuetzstellen - 1
Anzahl       = length(ttt)-1;
## Liste mit den Schrittweiten ttt(k+1)-ttt(k)
Schrittweite = ttt(2:length(ttt)) - ttt(1:length(ttt)-1);

## Ausgabe Bildschirm

h = figure(1);
Groesse = [15 5];
set (h,'papersize',Groesse)
set (h, 'paperposition', [0,0,Groesse]);
  # Exakte Loesung und Naererungen
  subplot(1,2,1)
    plot(ttt,erg(2,:),'-+','linewidth',2,'color','red')
    hold on
    plot(tte,xe(tte),'linewidth',2,'color',[.5 .5 .5]);
    xlabel('t'), ylabel('x(t)'), xlim([t0,T]);
    title(['Schrittweitensteuerung';... 
           '\alpha = ', num2str(alf), ', \sigma = ', num2str(sig),...
            ';  ',num2str(Anzahl), ' Schritte, ';...
            'Laufzeit: ',num2str(Zeit), ' Sekunden'])
    set(gca,'linewidth',2,'fontsize',18)
  # Schrittweiten
  subplot(1,2,2)
     plot(1:1:Anzahl,Schrittweite,'linewidth',2,'color','blue');
     xlabel('k'), ylabel('dt_k'), xlim([1,Anzahl]);
     title('Schrittweiten')
     set(gca,'linewidth',2,'fontsize',18)
hold off

# Abspeichern als Bild in akzeptabler Aufloesung.
# Veraendern von T oder N passt den Dateinamen an.
# Falls die Marker keine Kreise sind: "-painters" als Option einfuegen!
print ("-r600", "-painters", ["Aufgabe_1_6_5.png"]);   

