## Mathematikinformation Nr. 71 / 72
## http://mathematikinformation.info/
##
## Lei Baozhen, Beijing Union University
## Harald Loewe, Technische Universitaet Braunschweig
## Numerische Verfahren zur Loesung von Differentialgleichungen
##
#################################################################
## Loesung der Aufgabe 2.2.3: Ordnung des Euler-Heun-Verfahren ##
#################################################################
# Ver. 2019-12-15
# Kodierung in UTF-8; Octave-Version 5.10
##
## Ver. 2019-12-15
## Kodierung in UTF-8; Octave-Version 5.10

## Aufraeumen
clear -a;

## Festlegen des Anfangswertproblems
r     = 0.002;            # Wachstumsrate
K     = 10000;            # Grenzbestand
T     = 2;                # Intervallende
f     = @(t,x) r*x*(K-x); # rechte Seite der Differentialgleichung
t0    = 0;                # Intervallanfang
x0    = 3;                # Anfangswert

## Exakte Loesung
x     = @(t) K./(1+(K-x0)/x0*exp(-r*K*t));

## Festlegen der Stelle und der anfaenglichen Schrittweite
t1    = 0.4;              # Im steilen Abschnitt der Loesungskurve
x1    = x(t1);            # Exakter Wert
dt    = 0.0512;           # Anfaengliche Schrittweite

## Initialisierung von Listen
hh    = [];
f1    = [];
f2    = [];

## Berechnen eines Naeherungswerts fuer x(t1+dt)
   q1  = dt * f(t1,x1);
   q2  = dt * f(t1+dt,x1+q1);
   y1  = x1 + 0.5*(q1+q2);
for k = 1:11
   hh  = [hh, dt];
   f1  = [f1, y1 - x(t1+dt)];
   q1  = dt/2 * f(t1,x1);
   q2  = dt/2 * f(t1+dt/2,x1+q1);
   z1  = x1 + 0.5*(q1+q2);
   q1  = dt/2 * f(t1+dt/2,z1);
   q2  = dt/2 * f(t1+dt,z1+q1);
   z2  = z1 + 0.5*(q1+q2);
   f2  = [f2, z2 - x(t1+dt)];
   dt  = dt/2;
   y1 = z1;
endfor;
## Ausgabe auf der Konsole
hh      ## Verwendete Schrittweiten h
f1./f2  ## Quotient aus den Fehlern fuer die Schrittweite h und h/2

figure(1)
plot(hh,f1./f2,'linewidt',2,'color','red')
xlabel('Schrittweite h'), ylabel('Verhaeltnis der Fehler')
axis([hh(length(hh)),hh(1)])
set(gca,'linewidth',2,'fontsize',18)