## Mathematikinformation Nr. 71 / 72
## http://mathematikinformation.info/
##
## Lei Baozhen, Beijing Union University
## Harald Loewe, Technische Universitaet Braunschweig
## Numerische Verfahren zur Loesung von Differentialgleichungen
##
##############################################################
### Zu Aufgabe 2.4.2 (Systeme)                             ###
##############################################################
##
## Ver. 2019-12-15
## Kodierung in UTF-8; Octave-Version 5.10

## Initialisierung des Anfangswertproblems
AWP_init_241;


## Polygonzugverfahren mit und ohne Schrittweitensteuerung
opt        = {'alpha',10^-2,'sigma',0.8};
erg_PZ     = ODE_PZSW(f, t0, T, x0, opt);
erg_EH     = ODE_EHSW(f, t0, T, x0, opt);
erg_RK     = ODE_RKSW(f, t0, T, x0, opt);
erg_EHvsPZ = ODE_EHvsPZ(f, t0, T, x0, opt);

h = figure(1);
set (h,'papersize',[25 6])
set (h, 'paperposition', [0,0,[25 6]]);
  subplot (1, 4, 1)
    hold on
    plot(erg_PZ(1,:),erg_PZ(2,:),'linewidth',3,'color','blue');
    plot(erg_PZ(1,:),erg_PZ(3,:),'linewidth',3,'color','red');
    # Exakte Loesung UEBER der Naeherung, daher als zweites plotten
    plot(tte,xe1(tte),'linewidth',2,'color',[0 0 0.5]);
    plot(tte,xe2(tte),'linewidth',2,'color',[0.5 0 0]);
    xlabel('t'), ylabel('x_1 (blau);   x_2 (rot)')
    title(['ODE\_PZ;  N = ', num2str(size(erg_PZ)(2))])
    set(gca,'linewidth',2,'fontsize',18)
    hold off
  subplot (1, 4, 2)
    hold on
    plot(erg_EH(1,:),erg_EH(2,:),'linewidth',3,'color','blue');
    plot(erg_EH(1,:),erg_EH(3,:),'linewidth',3,'color','red');
    # Exakte Loesung UEBER der Naeherung, daher als zweites plotten
    plot(tte,xe1(tte),'linewidth',2,'color',[0 0 0.5]);
    plot(tte,xe2(tte),'linewidth',2,'color',[0.5 0 0]);
    xlabel('t'), ylabel('x_1 (blau);   x_2 (rot)')
    title(['ODE\_EH;  N = ', num2str(size(erg_EH)(2))])
    set(gca,'linewidth',2,'fontsize',18)
    hold off
  subplot (1, 4, 3)
    hold on
    plot(erg_RK(1,:),erg_RK(2,:),'linewidth',3,'color','blue');
    plot(erg_RK(1,:),erg_RK(3,:),'linewidth',3,'color','red');
    # Exakte Loesung UEBER der Naeherung, daher als zweites plotten
    plot(tte,xe1(tte),'linewidth',2,'color',[0 0 0.5]);
    plot(tte,xe2(tte),'linewidth',2,'color',[0.5 0 0]);
    xlabel('t'), ylabel('x_1 (blau);   x_2 (rot)')
    title(['ODE\_RK;  N = ', num2str(size(erg_RK)(2))])
    set(gca,'linewidth',2,'fontsize',18)
    hold off    
  subplot (1, 4, 4)
    hold on
    plot(erg_EHvsPZ(1,:),erg_EHvsPZ(2,:),'linewidth',3,'color','blue');
    plot(erg_EHvsPZ(1,:),erg_EHvsPZ(3,:),'linewidth',3,'color','red');
    # Exakte Loesung UEBER der Naeherung, daher als zweites plotten
    plot(tte,xe1(tte),'linewidth',2,'color',[0 0 0.5]);
    plot(tte,xe2(tte),'linewidth',2,'color',[0.5 0 0]);
    xlabel('t'), ylabel('x_1 (blau);   x_2 (rot)')
    title(['ODE\_EHvsPZ;  N = ', num2str(size(erg_EHvsPZ)(2))])
    set(gca,'linewidth',2,'fontsize',18)
    hold off
## Abspeichern als Bild in akzeptabler Aufloesung.
print ("-r600", "-painters", ["Aufgabe_2_4_1.png"]);